/*****************************************************
reseter 2.0
Chip type           : ATtiny13
Clock frequency     : 4,800000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 16
23.02.09
*****************************************************/

#include <tiny13.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>

#include <delay.h>
#include <stdlib.h>

/* read a byte from the EEPROM */
unsigned char eeprom_read(unsigned char EEPROMREAD, unsigned int address) 
{
unsigned char data;
i2c_start();
i2c_write(EEPROMREAD);
i2c_write(address);
i2c_start();
i2c_write(EEPROMREAD | 1);
data=i2c_read(0);
i2c_stop();
return data;
}

/* write a byte to the EEPROM */
void eeprom_write(unsigned char EEPROM, unsigned char address, unsigned char data) {
i2c_start();
i2c_write(EEPROM);
i2c_write(address);
i2c_write(data);
i2c_stop();
/* 20ms delay to complete the write operation */
delay_ms(20);
}

void main(void)
{
unsigned char EEPROM=0xa0; //  
unsigned char EEPROMREAD=0xa4; //   
unsigned char X = 0;//    3F
unsigned char Y = 0;//    3E
char READ = 0; //     
char VERIFY = 0; //      
unsigned int ADR = 0; //      - 
unsigned char ADRWRITE = 0; //      0x00- 0x3F
unsigned char STEP=144; //      (   )

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;

//*******************************
//  
//delay_us(5); 
//******************************
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State5=P State4=P State3=P State2=0 State1=T State0=T 
PORTB=0x38;
DDRB=0x04;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// I2C Bus initialization
i2c_init();

PORTB|=0x04; // 

    //        
    X = eeprom_read(EEPROM, 0x3F); //   
    Y = eeprom_read(EEPROM, 0x3D); //   
    X++;                     
    if(X > 0x39)   // 030-039
        X = 0x30;
    // 
    for(ADR = 0; ADR < 0x8F; ADR++)
        eeprom_write(EEPROM, ADR, 0xFF);    
    //  
    if((!PINB.3)&&(!PINB.4)) //Samsung 4200
        {
        ADR = 0x00; 
        } 
        else
            if((PINB.3)&&(!PINB.4)) //Samsung 4720 Xerox PE 120
                  {
                  ADR = 0x90;
                  }
                        else  
                              if((!PINB.3)&&(PINB.4)) //Xerox 3119
                                   {
                                   ADR = 0x120;
                                   }
    while(STEP > 0)
         {            
         //     EEPROM_BUS_ADDRESS1        
         //0x00 - 0x8F Samsung 4200
         //0x90 - 0x110F Samsung 4720 Xerox PE120
         //0x120 - 0x1AF  Xerox 3119   
         //        (0x100)-    0100
         //    0      0xA6 
         if(ADR>0xFF) 
                {
                ADR-=0x100;
                EEPROMREAD = 0xa6;
                }
         READ= eeprom_read(EEPROMREAD, ADR); 
         eeprom_write(EEPROM, ADRWRITE, READ); //        
         VERIFY= eeprom_read(EEPROM, ADRWRITE);// 
         if(VERIFY != READ) //   
                while(1)
                        {
                        PORTB.2 = 1; //   
                        delay_ms(200);
                        PORTB.2 = 0; //  
                        delay_ms(200);                        
                        }; //STOP
         ADRWRITE++; //         
         ADR++;  //              
             STEP--;
         } 
    //    
    eeprom_write(EEPROM, 0x3F, X);
    eeprom_write(EEPROM, 0x3E, Y); //   3E     3D 
    PORTB.2 = 0; //      
    delay_ms(500);     
    PORTB.2 = 1; //  
    delay_ms(500);     
    PORTB.2 = 0;
    delay_ms(500);     
    PORTB.2 = 1;
    delay_ms(500);     
    PORTB.2 = 0;
while (1)
      {
      };
}
