/*****************************************************
reseter 2.0
Chip type           : ATtiny13
Clock frequency     : 4,800000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 16
23.02.09
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny13


#pragma used+
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; // 16 bit access
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif



// I2C Bus functions
#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=0
   .equ __scl_bit=1
/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/* CodeVisionAVR C Compiler V2.0
   Prototypes for standard library functions

   (C) 1998-2008 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib



/* read a byte from the EEPROM */
unsigned char eeprom_read(unsigned char EEPROMREAD, unsigned int address) 
{
unsigned char data;
i2c_start();
i2c_write(EEPROMREAD);
i2c_write(address);
i2c_start();
i2c_write(EEPROMREAD | 1);
data=i2c_read(0);
i2c_stop();
return data;
}

/* write a byte to the EEPROM */
void eeprom_write(unsigned char EEPROM, unsigned char address, unsigned char data) {
i2c_start();
i2c_write(EEPROM);
i2c_write(address);
i2c_write(data);
i2c_stop();
/* 20ms delay to complete the write operation */
delay_ms(20);
}

void main(void)
{
unsigned char EEPROM=0xa0; //  
unsigned char EEPROMREAD=0xa4; //   
unsigned char X = 0;//    3F
unsigned char Y = 0;//    3E
char READ = 0; //     
char VERIFY = 0; //      
unsigned int ADR = 0; //      - 
unsigned char ADRWRITE = 0; //      0x00- 0x3F
unsigned char STEP=144; //      (   )

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;

//*******************************
//  
//delay_us(5); 
//******************************
CLKPR=0x00;
#pragma optsize+

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State5=P State4=P State3=P State2=0 State1=T State0=T 
PORTB=0x38;
DDRB=0x04;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// I2C Bus initialization
i2c_init();

PORTB|=0x04; // 

    //        
    X = eeprom_read(EEPROM, 0x3F); //   
    Y = eeprom_read(EEPROM, 0x3D); //   
    X++;                     
    if(X > 0x39)   // 030-039
        X = 0x30;
    // 
    for(ADR = 0; ADR < 0x8F; ADR++)
        eeprom_write(EEPROM, ADR, 0xFF);    
    //  
    if((!PINB.3)&&(!PINB.4)) //Samsung 4200
        {
        ADR = 0x00; 
        } 
        else
            if((PINB.3)&&(!PINB.4)) //Samsung 4720 Xerox PE 120
                  {
                  ADR = 0x90;
                  }
                        else  
                              if((!PINB.3)&&(PINB.4)) //Xerox 3119
                                   {
                                   ADR = 0x120;
                                   }
    while(STEP > 0)
         {            
         //     EEPROM_BUS_ADDRESS1        
         //0x00 - 0x8F Samsung 4200
         //0x90 - 0x110F Samsung 4720 Xerox PE120
         //0x120 - 0x1AF  Xerox 3119   
         //        (0x100)-    0100
         //    0      0xA6 
         if(ADR>0xFF) 
                {
                ADR-=0x100;
                EEPROMREAD = 0xa6;
                }
         READ= eeprom_read(EEPROMREAD, ADR); 
         eeprom_write(EEPROM, ADRWRITE, READ); //        
         VERIFY= eeprom_read(EEPROM, ADRWRITE);// 
         if(VERIFY != READ) //   
                while(1)
                        {
                        PORTB.2 = 1; //   
                        delay_ms(200);
                        PORTB.2 = 0; //  
                        delay_ms(200);                        
                        }; //STOP
         ADRWRITE++; //         
         ADR++;  //              
             STEP--;
         } 
    //    
    eeprom_write(EEPROM, 0x3F, X);
    eeprom_write(EEPROM, 0x3E, Y); //   3E     3D 
    PORTB.2 = 0; //      
    delay_ms(500);     
    PORTB.2 = 1; //  
    delay_ms(500);     
    PORTB.2 = 0;
    delay_ms(500);     
    PORTB.2 = 1;
    delay_ms(500);     
    PORTB.2 = 0;
while (1)
      {
      };
}
